#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <opencv/cv.h>
#include <opencv/highgui.h>
#include <ctime>

#ifndef _ICP_H_
#define _ICP_H_
#define M_PI 3.1415926535

typedef struct DATA_POINT {
	CvPoint3D64f *pt;
	int num;
} DATA_POINT;

typedef struct QUATERNION {
	double q0;
	double q1;
	double q2;
	double q3;
} QUATERNION;

typedef struct MOVEMENT {
	QUATERNION Q;
	CvPoint3D64f Trl;
} MOVEMENT;

void Free_Data_Points(DATA_POINT *pset);
void icp_func(MOVEMENT *delta, DATA_POINT *sel_data_set, DATA_POINT *model_set, DATA_POINT *model_gravi, 
int data_point_num, int model_point_num, float raw_sum[3]);

#endif /*_ICP_H_*/
