#include "LockObject.h"

LockObject::LockObject(void)
{
	::InitializeCriticalSection(&cs_);
}

LockObject::~LockObject(void)
{
	::DeleteCriticalSection(&cs_);
}

void LockObject::lock()
{
	::EnterCriticalSection(&cs_);
}

void LockObject::unlock()
{
	::LeaveCriticalSection(&cs_);
}